/**
 * Created by robin on 12/11/16.
 */

(function () {
    'use strict';
    angular.module('luticate2Utils')
        .factory('luWebApiCrudBusiness', ['luBusiness', '$q', function (luBusiness, $q) {

            var luWebApiCrudBusiness = {};

            luWebApiCrudBusiness.create = function (dataAccess) {
                var Business = luBusiness.create();

                Business.dataAccess = dataAccess;

                Business.initDbo = function(dbo)
                {
                    return Business.dataAccess.initDbo(dbo);
                };

                Business.initListDbo = function(list)
                {
                    return Business.dataAccess.initListDbo(list);
                };

                Business.initPaginatedDbo = function(data)
                {
                    return Business.dataAccess.initPaginatedDbo(data);
                };

                Business.thenInitDbo = function(promise)
                {
                    return Business.dataAccess.thenInitDbo(promise);
                };

                Business.thenInitListDbo = function(promise)
                {
                    return Business.dataAccess.thenInitListDbo(promise);
                };

                Business.thenInitPaginatedDbo = function(promise)
                {
                    return Business.dataAccess.thenInitPaginatedDbo(promise);
                };



                Business.getSingleById = function (id, luBusyGroups) {
                    return Business.dataAccess.getSingleById(id, luBusyGroups);
                };

                Business.getMultiple = function (orderBy, filter, page, perPage, luBusyGroups) {
                    return Business.dataAccess.getMultiple(orderBy, filter, page, perPage, luBusyGroups);
                };

                Business.addDbo = function(data, luBusyGroups) {
                    return Business.dataAccess.addDbo(data, luBusyGroups);
                };

                Business.editSingleByIdDbo = function(id, data, luBusyGroups) {
                    return Business.dataAccess.editSingleByIdDbo(id, data, luBusyGroups);
                };

                Business.deleteDbo = function(id, luBusyGroups) {
                    return Business.dataAccess.deleteDbo(id, luBusyGroups);
                };

                return Business;
            };

            return luWebApiCrudBusiness;

        }]);
})();